#!/bin/sh
#------------------------------------------------------------------------------
# main_Seti-Proxy.cgi - toggle Seti-Proxy on/off and Administration
#
# this file is part of the opt_setiproxy package for fli4l
# by:        Gerd Walter     <fli4l@gdw.claranet.de>
# thanks to: Stefan Hoffmann <hoffmann.stefan@gmx.de>
#------------------------------------------------------------------------------

SEC_REALM='misc'
SEC_ACTION='seti-proxy'
. sec-lib.cgi
. /etc/setiproxy.conf
. $SETIPROXYDIR/setiproxy.properties

RTIME=10

myname=`basename $0`

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head>"
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"$RTIME;URL=$myname\">"
echo "<title>Seti-Proxy</title>"
echo "</head><body>"
echo "<h1>Seti-Proxy on/off</h1>"
echo "<pre>"
if [ "$QUERY_STRING" = "start" ]
then
  /usr/bin/setiproxy
  sleep 5
elif [ "$QUERY_STRING" = "stop" ]
then
  /usr/bin/setiproxystop
  sleep 5
fi
echo "</pre>"

if ps -ax|grep java|grep -v grep >/dev/null; then
  status=""
  startstopurl="<a href=\"$myname?stop\">anhalten</a>"
  ipadresse=`/sbin/ifconfig $SETIPROXYINTERFACE | grep inet | cut -d':' -f2 | cut -d' ' -f1`
  color="#00FF00"
else
  status=" nicht"
  startstopurl="<a href=\"$myname?start\">starten</a>"
  color="#FF0000"
fi

echo "<table bgcolor=$color><tr><td>"
echo "Seti-Proxy luft momentan$status! ($startstopurl)"
echo "</td></tr></table>"

if [ "$status" = "" ]; then
  echo "<br><br><a href=\"http://$ipadresse:$adminport\">Seti-Proxy Web-Interface aufrufen</a>"
fi

echo "</body></html>"

